<template>
  <div
    data-component-group="form"
    data-component="edit-user"
    :class="getDenyReasonFormClass()"
  >
    <div class="component-header">
      <Can
        I="approve-deny-user"
        a="user"
      >
        <div
          v-if="canUpdateUserStatus"
          class="deny-reason-box"
        >
          <DenyReasonForm
            @deny-reason="denyUser"
            @cancel-deny-reason="onToggleDenyReasonForm"
          />
        </div>

        <div
          v-if="isPendingUser"
          class="pending-actions"
        >
          <v-btn
            class="primary trigger allow-user"
            @click="allowUser"
          >
            <v-icon>
              thumb_up
            </v-icon>
            {{ 'Allow' }}
          </v-btn>
          <v-btn
            class="secondary trigger deny-user"
            @click="onToggleDenyReasonForm"
          >
            <v-icon>
              thumb_down
            </v-icon>
            {{ 'Deny' }}
          </v-btn>
        </div>
      </Can>

      <template v-if="canLogIntoAccount">
        <Can
          I="login-into-mc-kmc-profile-as-am"
          a="user"
        >
          <v-btn
            v-if="!isPendingUser && isBusinessContact"
            class="elevation-0 trigger log-into-account"
            @click="logIntoUserAccount"
          >
            {{ 'Log into user account' }}
          </v-btn>
        </Can>
      </template>
    </div>

    <div class="component-body">
      <layout-section-header
        title="Personal details"
        :trigger-label="!canEditDetails ? 'Edit details' : 'Close'"
        @toggle="toggleEditDetails"
      />

      <UserForm
        :user="user"
        confirm-trigger-label="Update user"
        submit-trigger-icon="account_circle"
        :is-disabled="!canEditDetails"
        :is-loading="isLoading"
        :is-cleared="isCleared"
        :on-submit="onSubmit"
      />

      <Can
        I="see-profile-settings"
        a="user"
      >
        <layout-section-header
          title="Settings"
          :trigger-label="!canEditSettings ? 'Edit settings' : 'Close'"
          @toggle="toggleSettings"
        />

        <UserSettingsForm
          v-if="settings.length > 0"
          :settings="settings"
          :is-disabled="!canEditSettings"
          :on-submit="onUpdateSettings"
        />
      </Can>

      <template
        v-if="canViewNotifications
          && ($ability.can('manage-notifications', 'user')
          || $ability.can('get-notifications', 'user'))"
      >
        <layout-section-header
          title="Notifications"
          :trigger-label="!canEditNotifications ? 'Edit notifications' : 'Close'"
          @toggle="toggleEditNotifications"
        />

        <NotificationsForm
          :user="user"
          :is-disabled="!canEditNotifications"
        />
      </template>

      <layout-section-header
        title="User activity"
        :has-trigger="false"
      />

      <ActivityLogs
        v-if="activityLogs.length > 0"
        :rows="activityLogs"
        :pagination="pagination"
        @change-page="onChangeActivityLogsPage"
      />
    </div>
  </div>
</template>

<script>
  import UserForm from './AddNew';
  import ActivityLogs from '../../lists/ActivityLogs';
  import UserSettingsForm from './Settings';
  import NotificationsForm from './Notifications';
  import DenyReasonForm from './DenyReason';
  import { isArr, isObj, eachProp, hasProp } from '../../../utils';
  import defaultPagination from '../../../config/pagination';

  // TODO: Translate component

  // TODO: Extract deny-allow UI ('deny-reason-box', 'pending-actions') into a stand-alone component

  // TODO: Request that the api returns labels for users settings
  const settingLabels = {
    block_user: 'Block',
    notif_user: 'Receive notifications'
  };

  export default {
    components: {
      UserForm,
      ActivityLogs,
      UserSettingsForm,
      NotificationsForm,
      DenyReasonForm
    },
    props: {
      user: {
        type: Object,
        required: true
      },
      isLoading: {
        type: Boolean,
        default: false
      },
      isCleared: {
        type: Boolean,
        default: true
      },
      onCancel: {
        type: Function,
        default: undefined
      },
      onSubmit: {
        type: Function,
        default: undefined
      },
    },
    data() {
      return {
        pagination: {
          ...defaultPagination
        },
        canEditDetails: false,
        canEditSettings: false,
        canUpdateUserStatus: true,
        isDenyReasonFormOn: false,
        canEditNotifications: false
      };
    },
    computed: {
      isPendingUser() {
        const { user } = this;
        return isObj(user.status) && user.status.name.toLowerCase() === 'pending review';
      },
      isBusinessContact() {
        const { user } = this;
        return isObj(user.role) && user.role.slug === 'business_contact';
      },
      isSuperAdmin() {
        const { user } = this;
        return isObj(user.role) && user.role.slug === 'super_admin';
      },
      activityLogs() {
        const { log } = this.$store.getters['users/activeItem'];
        return log.items;
      },
      settings() {
        const { settings } = this.$store.getters['users/activeItem'];
        return this.unwrapSettings(settings);
      },
      isVerified() {
        return this.user.verified === 1;
      },
      canLogIntoAccount() {
        return isArr(this.user.permissions)
          && this.user.permissions.indexOf('am-can-log-into-this-profile') > -1
          && !this.isPendingUser
          && this.isVerified;
      },
      canViewNotifications() {
        return isArr(this.user.permissions)
          && this.user.permissions.indexOf('get-notifications') > -1;
      }
    },
    watch: {
      user(nextUser) {
        if (isObj(nextUser)) {
          this.canEditDetails = false;
          this.pagination = defaultPagination;

          this.getActivityLogs(nextUser);
          this.getSettings(nextUser);
        }
      }
    },
    methods: {
      logIntoUserAccount() {
        return this.$store.dispatch('auth/logIntoAccount', this.user);
      },
      toggleEditDetails() {
        this.canEditDetails = !this.canEditDetails;
      },
      toggleSettings() {
        this.canEditSettings = !this.canEditSettings;
      },
      unwrapSettings(settings) {
        const nextSettings = [];

        eachProp(settings, (isOn, key) => {
          if (key === 'block_user' && !this.$ability.can('change-status', 'user')) {
            return false;
          }

          nextSettings.push({
            label: this.getSettingLabel(key),
            key,
            isOn: isOn > 0
          });
        });

        return nextSettings;
      },
      wrapSettings() {
        const nextSettings = {};

        this.settings.forEach(({ isOn, key }) => {
          if (key === 'block_user' && !this.$ability.can('change-status', 'user')) {
            return false;
          }

          nextSettings[key] = isOn ? 1 : 0;
        });

        return nextSettings;
      },
      getSettingLabel(settingKey) {
        return hasProp(settingLabels, settingKey)
          ? settingLabels[settingKey]
          : settingKey;
      },
      getActivityLogs({ id }) {
        const { page, perPage } = this.pagination;
        const query = {
          id,
          page,
          perPage
        };

        return this.$store.dispatch('users/getActivityLogs', query)
          .then((res) => {
            const hasErrors = this.$store.getters['alerts/error'].length > 0;

            if (hasErrors) {
              return false;
            }

            const { log } = this.$store.getters['users/activeItem'];
            const { total, current_page, last_page } = log.meta;

            this.pagination.page = current_page;
            this.pagination.totalItems = total;
            this.pagination.lastPage = last_page;

            return res;
          });
      },
      getSettings({ id }) {
        const query = { id };

        return this.$store.dispatch('users/getSettings', query);
      },
      getNotifications({ id }) {
        const query = { id };

        return this.$store.dispatch('users/getNotifications', query);
      },
      getNotificationAssignments() {

      },
      onChangeActivityLogsPage(page) {
        this.pagination.page = page;
        this.getActivityLogs(this.user);
      },
      onUpdateSettings() {
        const { user, settings } = this;
        const convertedSettings = this.wrapSettings(settings);

        const query = {
          id: user.id,
          settings: convertedSettings
        };

        return this.$store.dispatch('users/updateSettings', query)
          .then(() => this.toggleSettings());
      },
      updateUserStatus(status = 0, reason = '') {
        const { user } = this;
        const { id, firstname, lastname } = user;

        const query = {
          reason,
          id,
          firstname,
          lastname,
          status
        };

        return this.$store.dispatch('users/updateStatus', query)
          .then((res) => {
            this.isDenyReasonFormOn = false;
            this.canUpdateUserStatus = false;
            return res;
          });
      },
      denyUser(reason) {
        this.updateUserStatus(0, reason);
      },
      allowUser() {
        this.updateUserStatus(1);
      },
      onToggleDenyReasonForm() {
        this.isDenyReasonFormOn = !this.isDenyReasonFormOn;
      },
      toggleEditNotifications() {
        this.canEditNotifications = !this.canEditNotifications;
      },
      getDenyReasonFormClass() {
        return {
          'deny-form-active': this.isDenyReasonFormOn
        };
      }
    },
  };
</script>

<style lang="stylus" scoped>
  @import '../../../assets/stylus/theme.styl';

  [data-component-group="form"] {
    &[data-component="edit-user"] {
      > .component-header {
        position: relative;
      }

      &.deny-form-active {
        .deny-reason-box {
          opacity: 1;
          pointer-events: all;
          transition: all 0.15s ease-in-out;
        }

        > .component-body {
          opacity: 0;
          pointer-events: none;
          transition: all 0.15s ease-in-out;
        }
      }

      > .component-body {
        opacity: 1;
        pointer-events: all;
        transition: all 0.15s ease-in-out;
      }

      .deny-reason-box {
        opacity: 0;
        pointer-events: none;
        position: absolute;
        top: 49px;
        left: -31px;
        width: calc(100% + 62px);
        padding: 20px;
        z-index: 100;
        background-color: $colors.shades.white;
        transition: all 0.15s ease-in-out;
      }

      .trigger.log-into-account,
      .trigger.allow-user,
      .trigger.deny-user {
        height: 28px;
        border-radius: 4px;
        margin: 0;
        font-size: 12px;

        .v-icon {
          margin: 0 6px 0 0;
          font-size: 16px;
        }

        &:before {
          background-color: $colors.grey.base;
        }
      }

      .trigger.allow-user {
        margin: 0 10px 0 0;
      }

      .trigger.log-into-account {
        margin: 6px 0 0 0;
      }
    }
  }
</style>
